/*****************************************************************************/
/*  MXAPI.H   MS-WINDOWS Win32 & Win64 (95/98/NT/2K/XP/XP64)                 */
/*                                                                           */
/*  (C) TDi GmbH                                                             */
/*                                                                           */
/*  Include File for Visual C/C++ (32- and 64-Bit)                           */
/*****************************************************************************/
#ifndef _MATRIXMEMAPI_H
#define _MATRIXMEMAPI_H

#include "mxtypes.h"     // platform independent data types

#ifdef __cplusplus
extern "C" {
#endif

	_mxINT16  __stdcall Init_MatrixAPI(bool bCoInitialize=true);
	_mxINT16 WINAPI Reset_MatrixAPI();
	_mxINT16  __stdcall Release_MatrixAPI(void);
	_mxINT32  __stdcall GetVersionAPI(void);
	_mxINT16  __stdcall Dongle_WriteData(_mxINT32, _mxINT32*, _mxINT16, _mxINT16, _mxINT16);
	_mxINT16  __stdcall Dongle_WriteDataEx(_mxINT32, _mxINT32*, _mxINT16, _mxINT16, _mxINT16, _mxINT16);
	_mxINT16  __stdcall Dongle_ReadData(_mxINT32, _mxINT32*, _mxINT16, _mxINT16, _mxINT16);
	_mxINT16  __stdcall Dongle_ReadDataEx(_mxINT32, _mxINT32*, _mxINT16, _mxINT16, _mxINT16, _mxINT16);
	_mxINT32  __stdcall Dongle_ReadSerNr(_mxINT32, _mxINT16, _mxINT16);
	_mxINT32  __stdcall Dongle_Version(_mxINT16, _mxINT16);
	_mxINT32  __stdcall Dongle_Model(_mxINT16, _mxINT16);
	_mxINT16  __stdcall Dongle_MemSize(_mxINT16, _mxINT16);
	_mxINT16  __stdcall Dongle_Count(_mxINT16);

	_mxINT16  __stdcall Dongle_WriteKey(_mxINT32 UserCode,    _mxUINT32 *KeyData,  _mxINT16 DongleNr, _mxINT16 PortNr);
	_mxINT16  __stdcall Dongle_EncryptData(_mxINT32 UserCode, _mxUINT32 *DataBlock, _mxINT16 DongleNr, _mxINT16 PortNr);
	_mxINT16  __stdcall Dongle_DecryptData(_mxINT32 UserCode, _mxUINT32 *DataBlock, _mxINT16 DongleNr, _mxINT16 PortNr);
	_mxINT16  __stdcall Dongle_GetKeyFlag(_mxINT32 UserCode, _mxINT16 DongleNr, _mxINT16 PortNr);

	_mxINT16 __stdcall Init_UsbMemDetect(void (*)(void*), void (*)(void*), void*);
	_mxINT16 __stdcall Release_UsbMemDetect();

#ifdef __cplusplus
}
#endif

#endif  // _MATRIXAPI_H

