using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;


namespace matrix
{
	/// <summary>
	/// Zusammenfassung fE Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		public System.Windows.Forms.GroupBox Frame2;
		internal System.Windows.Forms.ComboBox Combo1;
		public System.Windows.Forms.Button Command1;
		public System.Windows.Forms.GroupBox Frame1;
		public System.Windows.Forms.RadioButton _Option1_4;
		public System.Windows.Forms.RadioButton _Option1_8;
		public System.Windows.Forms.RadioButton _Option1_9;
		public System.Windows.Forms.RadioButton _Option1_6;
		public System.Windows.Forms.RadioButton _Option1_5;
		public System.Windows.Forms.RadioButton _Option1_3;
		public System.Windows.Forms.RadioButton _Option1_2;
		public System.Windows.Forms.RadioButton _Option1_1;
		public System.Windows.Forms.ToolTip ToolTip1;
        public RadioButton _Option1_11;
        private System.ComponentModel.IContainer components;

        //
        // reference to matrix32memClass.dll is required
        //
        matrix32mem.Detect detectAPI = new matrix32mem.Detect();

        protected AsyncOperation AsyncOp;
        int nConnectedFlag = -1;

        public void OnConnect(IntPtr arg)
        {
            AsyncOp.Post(OnUSBKeyConnected, EventArgs.Empty);
            nConnectedFlag = 1;
        }
        public void OnDisConnect(IntPtr arg)
        {
            AsyncOp.Post(OnUSBKeyDisConnected, EventArgs.Empty);
            nConnectedFlag = 0;
        }

        public Form1()
		{
			//
			// Erforderlich fE die Windows Form-DesignerunterstEzung
			//
			InitializeComponent();

            //
            // TODO
            //
            AsyncOp = AsyncOperationManager.CreateOperation(null);
            detectAPI.Init(new matrix32mem.Detect.UsbMemDetectDelegate(this.OnConnect), new matrix32mem.Detect.UsbMemDetectDelegate(this.OnDisConnect));

        }

        void OnUSBKeyConnected(Object state)
        {
            this.Text = "Connected";
        }
        void OnUSBKeyDisConnected(Object state)
        {
            this.Text = "Disconnected";
        }

        /// <summary>
        /// Die verwendeten Ressourcen bereinigen.
        /// </summary>
        protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
                    detectAPI.Release();
                }
            }
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fE die DesignerunterstEzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.Frame2 = new System.Windows.Forms.GroupBox();
            this.Combo1 = new System.Windows.Forms.ComboBox();
            this.Command1 = new System.Windows.Forms.Button();
            this.Frame1 = new System.Windows.Forms.GroupBox();
            this._Option1_11 = new System.Windows.Forms.RadioButton();
            this._Option1_4 = new System.Windows.Forms.RadioButton();
            this._Option1_8 = new System.Windows.Forms.RadioButton();
            this._Option1_9 = new System.Windows.Forms.RadioButton();
            this._Option1_6 = new System.Windows.Forms.RadioButton();
            this._Option1_5 = new System.Windows.Forms.RadioButton();
            this._Option1_3 = new System.Windows.Forms.RadioButton();
            this._Option1_2 = new System.Windows.Forms.RadioButton();
            this._Option1_1 = new System.Windows.Forms.RadioButton();
            this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.Frame2.SuspendLayout();
            this.Frame1.SuspendLayout();
            this.SuspendLayout();
            // 
            // Frame2
            // 
            this.Frame2.BackColor = System.Drawing.SystemColors.Control;
            this.Frame2.Controls.Add(this.Combo1);
            this.Frame2.ForeColor = System.Drawing.SystemColors.ControlText;
            this.Frame2.Location = new System.Drawing.Point(16, 12);
            this.Frame2.Name = "Frame2";
            this.Frame2.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.Frame2.Size = new System.Drawing.Size(402, 93);
            this.Frame2.TabIndex = 16;
            this.Frame2.TabStop = false;
            this.Frame2.Text = "Select Port";
            // 
            // Combo1
            // 
            this.Combo1.Items.AddRange(new object[] {
            "USB"});
            this.Combo1.Location = new System.Drawing.Point(64, 38);
            this.Combo1.Name = "Combo1";
            this.Combo1.Size = new System.Drawing.Size(192, 29);
            this.Combo1.TabIndex = 0;
            this.Combo1.Text = "USB";
            // 
            // Command1
            // 
            this.Command1.BackColor = System.Drawing.SystemColors.Control;
            this.Command1.Cursor = System.Windows.Forms.Cursors.Default;
            this.Command1.ForeColor = System.Drawing.SystemColors.ControlText;
            this.Command1.Location = new System.Drawing.Point(16, 520);
            this.Command1.Name = "Command1";
            this.Command1.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.Command1.Size = new System.Drawing.Size(402, 65);
            this.Command1.TabIndex = 15;
            this.Command1.Text = "Start Function";
            this.Command1.UseVisualStyleBackColor = false;
            this.Command1.Click += new System.EventHandler(this.Command1_Click);
            // 
            // Frame1
            // 
            this.Frame1.BackColor = System.Drawing.SystemColors.Control;
            this.Frame1.Controls.Add(this._Option1_11);
            this.Frame1.Controls.Add(this._Option1_4);
            this.Frame1.Controls.Add(this._Option1_8);
            this.Frame1.Controls.Add(this._Option1_9);
            this.Frame1.Controls.Add(this._Option1_6);
            this.Frame1.Controls.Add(this._Option1_5);
            this.Frame1.Controls.Add(this._Option1_3);
            this.Frame1.Controls.Add(this._Option1_2);
            this.Frame1.Controls.Add(this._Option1_1);
            this.Frame1.ForeColor = System.Drawing.SystemColors.ControlText;
            this.Frame1.Location = new System.Drawing.Point(16, 116);
            this.Frame1.Name = "Frame1";
            this.Frame1.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.Frame1.Size = new System.Drawing.Size(402, 384);
            this.Frame1.TabIndex = 14;
            this.Frame1.TabStop = false;
            this.Frame1.Text = "Dongle-Test";
            // 
            // _Option1_11
            // 
            this._Option1_11.BackColor = System.Drawing.SystemColors.Control;
            this._Option1_11.Cursor = System.Windows.Forms.Cursors.Default;
            this._Option1_11.ForeColor = System.Drawing.SystemColors.ControlText;
            this._Option1_11.Location = new System.Drawing.Point(36, 347);
            this._Option1_11.Name = "_Option1_11";
            this._Option1_11.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this._Option1_11.Size = new System.Drawing.Size(322, 27);
            this._Option1_11.TabIndex = 20;
            this._Option1_11.TabStop = true;
            this._Option1_11.Text = "App_Encrypt";
            this._Option1_11.UseVisualStyleBackColor = false;
            // 
            // _Option1_4
            // 
            this._Option1_4.BackColor = System.Drawing.SystemColors.Control;
            this._Option1_4.Cursor = System.Windows.Forms.Cursors.Default;
            this._Option1_4.ForeColor = System.Drawing.SystemColors.ControlText;
            this._Option1_4.Location = new System.Drawing.Point(36, 154);
            this._Option1_4.Name = "_Option1_4";
            this._Option1_4.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this._Option1_4.Size = new System.Drawing.Size(306, 26);
            this._Option1_4.TabIndex = 6;
            this._Option1_4.TabStop = true;
            this._Option1_4.Text = "Read_Dongle_SerNr";
            this._Option1_4.UseVisualStyleBackColor = false;
            // 
            // _Option1_8
            // 
            this._Option1_8.BackColor = System.Drawing.SystemColors.Control;
            this._Option1_8.Cursor = System.Windows.Forms.Cursors.Default;
            this._Option1_8.ForeColor = System.Drawing.SystemColors.ControlText;
            this._Option1_8.Location = new System.Drawing.Point(36, 271);
            this._Option1_8.Name = "_Option1_8";
            this._Option1_8.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this._Option1_8.Size = new System.Drawing.Size(322, 28);
            this._Option1_8.TabIndex = 10;
            this._Option1_8.TabStop = true;
            this._Option1_8.Text = "Encrypt / Decrypt Data";
            this._Option1_8.UseVisualStyleBackColor = false;
            // 
            // _Option1_9
            // 
            this._Option1_9.BackColor = System.Drawing.SystemColors.Control;
            this._Option1_9.Cursor = System.Windows.Forms.Cursors.Default;
            this._Option1_9.ForeColor = System.Drawing.SystemColors.ControlText;
            this._Option1_9.Location = new System.Drawing.Point(36, 311);
            this._Option1_9.Name = "_Option1_9";
            this._Option1_9.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this._Option1_9.Size = new System.Drawing.Size(322, 26);
            this._Option1_9.TabIndex = 11;
            this._Option1_9.TabStop = true;
            this._Option1_9.Text = "Get Version of Matrix-API";
            this._Option1_9.UseVisualStyleBackColor = false;
            // 
            // _Option1_6
            // 
            this._Option1_6.BackColor = System.Drawing.SystemColors.Control;
            this._Option1_6.Cursor = System.Windows.Forms.Cursors.Default;
            this._Option1_6.ForeColor = System.Drawing.SystemColors.ControlText;
            this._Option1_6.Location = new System.Drawing.Point(36, 231);
            this._Option1_6.Name = "_Option1_6";
            this._Option1_6.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this._Option1_6.Size = new System.Drawing.Size(322, 28);
            this._Option1_6.TabIndex = 8;
            this._Option1_6.TabStop = true;
            this._Option1_6.Text = "Write_Dongle_Data";
            this._Option1_6.UseVisualStyleBackColor = false;
            // 
            // _Option1_5
            // 
            this._Option1_5.BackColor = System.Drawing.SystemColors.Control;
            this._Option1_5.Cursor = System.Windows.Forms.Cursors.Default;
            this._Option1_5.ForeColor = System.Drawing.SystemColors.ControlText;
            this._Option1_5.Location = new System.Drawing.Point(36, 192);
            this._Option1_5.Name = "_Option1_5";
            this._Option1_5.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this._Option1_5.Size = new System.Drawing.Size(322, 28);
            this._Option1_5.TabIndex = 7;
            this._Option1_5.TabStop = true;
            this._Option1_5.Text = "Read_Dongle_Data";
            this._Option1_5.UseVisualStyleBackColor = false;
            // 
            // _Option1_3
            // 
            this._Option1_3.BackColor = System.Drawing.SystemColors.Control;
            this._Option1_3.Cursor = System.Windows.Forms.Cursors.Default;
            this._Option1_3.ForeColor = System.Drawing.SystemColors.ControlText;
            this._Option1_3.Location = new System.Drawing.Point(36, 116);
            this._Option1_3.Name = "_Option1_3";
            this._Option1_3.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this._Option1_3.Size = new System.Drawing.Size(322, 28);
            this._Option1_3.TabIndex = 5;
            this._Option1_3.TabStop = true;
            this._Option1_3.Text = "Version_of_Dongle";
            this._Option1_3.UseVisualStyleBackColor = false;
            // 
            // _Option1_2
            // 
            this._Option1_2.BackColor = System.Drawing.SystemColors.Control;
            this._Option1_2.Cursor = System.Windows.Forms.Cursors.Default;
            this._Option1_2.ForeColor = System.Drawing.SystemColors.ControlText;
            this._Option1_2.Location = new System.Drawing.Point(36, 75);
            this._Option1_2.Name = "_Option1_2";
            this._Option1_2.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this._Option1_2.Size = new System.Drawing.Size(322, 28);
            this._Option1_2.TabIndex = 4;
            this._Option1_2.TabStop = true;
            this._Option1_2.Text = "Memory_of_Dongle";
            this._Option1_2.UseVisualStyleBackColor = false;
            // 
            // _Option1_1
            // 
            this._Option1_1.BackColor = System.Drawing.SystemColors.Control;
            this._Option1_1.Cursor = System.Windows.Forms.Cursors.Default;
            this._Option1_1.ForeColor = System.Drawing.SystemColors.ControlText;
            this._Option1_1.Location = new System.Drawing.Point(36, 38);
            this._Option1_1.Name = "_Option1_1";
            this._Option1_1.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this._Option1_1.Size = new System.Drawing.Size(322, 27);
            this._Option1_1.TabIndex = 3;
            this._Option1_1.TabStop = true;
            this._Option1_1.Text = "Number_of_Dongles";
            this._Option1_1.UseVisualStyleBackColor = false;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(10, 21);
            this.ClientSize = new System.Drawing.Size(446, 620);
            this.Controls.Add(this.Frame2);
            this.Controls.Add(this.Command1);
            this.Controls.Add(this.Frame1);
            this.Name = "Form1";
            this.Text = "Form1";
            this.Frame2.ResumeLayout(false);
            this.Frame1.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fE die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Command1_Click(object sender, System.EventArgs e)
		{
			Funktionen();
		}

		private void Funktionen()
		{
			MatrixDemo demo = new MatrixDemo();
			
			if(_Option1_1.Checked)
			{
				demo.SetActivePort(Combo1.Text);
				demo.Number_of_Dongles();
			}

			if(_Option1_2.Checked)
			{
				demo.SetActivePort(Combo1.Text);
				demo.Memory_of_Dongle();
			}

			if(_Option1_3.Checked)
			{
				demo.SetActivePort(Combo1.Text);
				demo.Version_of_Dongle();
			}

			if(_Option1_4.Checked)
			{
				demo.SetActivePort(Combo1.Text);
				demo.Read_Dongle_SerNr();
			}

			if(_Option1_5.Checked)
			{
				demo.SetActivePort(Combo1.Text);
				demo.Read_Dongle_Data();
			}

			if(_Option1_6.Checked)
			{
				demo.SetActivePort(Combo1.Text);
				demo.Write_Dongle_Data();
			}


			if(_Option1_8.Checked)
			{
				demo.SetActivePort(Combo1.Text);
				demo.Dongle_Encrypt_Decrypt();
			}

			if(_Option1_9.Checked)
			{
				demo.SetActivePort(Combo1.Text);
				demo.Version_of_API();
			}


			if(_Option1_11.Checked)
			{
				demo.SetActivePort(Combo1.Text);
				demo.App_Encrypt();
			}

        }

    }
}
